(******************************************************************************)
(* generator (stack machine)                                                  *)
(* (C) 2010 Steffen Solyga <solyga@absinth.net>                               *)
(******************************************************************************)
DEFINITION MODULE Gen;

IMPORT Comp;

TYPE
  TValue = Comp.TValue;
  TIndex = Comp.TIndex;

  TOp0 = ( oWrt, oWrB );
  TOp1 = ( oNeg, oNot );
  TOp2 = (
    oNull,
    oAdd, oSub, oMul, oDiv, oOr,  oAnd,
    oEql, oNeq, oLss, oLeq, oGtr, oGeq
  );

  TItemDesc = RECORD
    CASE c: BOOLEAN OF  (* const *)
    | TRUE : v: TValue;
    | FALSE: (* stack *);
    END;
  END;


PROCEDURE Val( v: TValue );
PROCEDURE Sto( i: TIndex );
PROCEDURE Lod( i: TIndex );
PROCEDURE Op0( o: TOp0 );
PROCEDURE Op1( o: TOp1; VAR d: TItemDesc );
PROCEDURE Op2( o: TOp2; VAR d, d1: TItemDesc );

CONST
  vFalse = Comp.vFalse;
  vTrue  = Comp.vTrue;

END Gen.
